sub escapeQuotes {
    my $str = shift;
    $str =~ s/'/\\'/g;
    $str =~ s/"/\\"/g;
    return $str;
}

sub renderRows {
    my $obj    = shift;
    my $onlyCategories = shift || 0;
    my $list   = $obj->data;
    my $colone = $obj->self->env->{'columnOne'};
    my($row,@flds,%data);

    unless( $onlyCategories ) {
        $list->reset();
        my @p;
        while( $row = $list->fetchrow ) {
            $row = $obj->self->mkCliObject( $row );
            push(@p, sprintf("'%s'", escapeQuotes($row->field( $colone ))));
        }
        $obj->self->doOutput( join(', ', @p) );
        return;
    }

    $row = $obj->self->mkCliObject( $list->getrow(0) );

    for my $fld ( sort( $row->getFieldList )) {
        unless ( $fld eq $colone ) {
            push @flds, $fld;
        }
    }

    $list->reset();
    while( $row = $list->fetchrow ) {
        $row = $obj->self->mkCliObject( $row );
        for my $fld (@flds) {
            my $val = $row->field( $fld );
            $val = 'null' if ( $val eq '' );
            push(@{$data{$fld}}, sprintf("%s", $val));
        }
    }

    my @outstr;
    for my $fld (@flds) {
        my $str = join(', ', @{$data{$fld}});
        $fld = escapeQuotes($fld);
        push(@outstr, "{ name: '$fld', data: [ $str ] }");
    }
    $obj->self->doOutput( join(",\n", @outstr) );

}

1;
